/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: XMLAttr.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_XMLAttr_H
#define OpenSOAP_XMLAttr_H

#include <OpenSOAP/XMLNamespace.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPXMLAttr OpenSOAPXMLAttr;
    typedef OpenSOAPXMLAttr *OpenSOAPXMLAttrPtr;

    int
    OPENSOAP_API
    OpenSOAPXMLAttrCreateMB(const char * /* [in] */ attr_name,
                            OpenSOAPXMLAttrPtr * /* [out] */ attr);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrCreateWC(const wchar_t * /* [in] */ attr_name,
                            OpenSOAPXMLAttrPtr * /* [out] */ attr);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrSetNamespaceMB(OpenSOAPXMLAttrPtr /* [in, out] */ elm,
                                  const char * /* [in] */ ns_uri,
                                  const char * /* [in] */ ns_prefix);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrSetNamespaceWC(OpenSOAPXMLAttrPtr /* [in, out] */ elm,
                                  const wchar_t * /* [in] */ ns_uri,
                                  const wchar_t * /* [in] */ ns_prefix);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrGetNamespace(OpenSOAPXMLAttrPtr /* [in, out] */ elm,
                                OpenSOAPXMLNamespacePtr * /* [out] */ ns);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrGetValueMB(OpenSOAPXMLAttrPtr /* [in] */ elm,
                              const char * /* [in] */ type_name,
                              void * /* [out] */ value);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrGetValueWC(OpenSOAPXMLAttrPtr /* [in] */ elm,
                              const wchar_t * /* [in] */ type_name,
                              void * /* [out] */ value);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrSetValueMB(OpenSOAPXMLAttrPtr /* [in] */ elm,
                              const char * /* [in] */ type_name,
                              void * /* [in] */ value);

    int
    OPENSOAP_API
    OpenSOAPXMLAttrSetValueWC(OpenSOAPXMLAttrPtr /* [in] */ elm,
                              const wchar_t * /* [in] */ type_name,
                              void * /* [in] */ value);
    
	int
	OPENSOAP_API
	OpenSOAPXMLAttrGetName(OpenSOAPXMLAttrPtr /* [in] */ attr,
						   OpenSOAPStringPtr * /* [out] */ name);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_XMLAttr_H */
