/*-----------------------------------------------------------------------------
 * $RCSfile: OpenSOAP.c,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#if (!defined(_WIN32)) || defined(_DEBUG)
static  const   char    CVS_ID[]        =       "$Id: OpenSOAP.c,v 1.10 2001/12/18 02:00:44 bandou Exp $";
#endif  /* _DEBUG */

#include <OpenSOAP/OpenSOAP.h>
#include <OpenSOAP/ErrorCode.h>
#include <OpenSOAP/Serializer.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <locale.h>

#if defined(WIN32) && !defined(__GNUC__)
#define NONGCC_WIN32 1
#endif /* */


/*
=begin
= OpenSOAP API initialize and ultimate
=end
*/


/*
=begin
---OpenSOAPInitialize(param)
   OpenSOAP API initalize. In this function, Serializer/Deserializer
   regist. If use COM in OpenSOAP API, then CoInitilizeEx is called.

   :Parameters
     :void * [in] ((|param|))
       Initalize parameter. Currently, this parameter is no mean.
   :Return Value
     :int
=end
*/
extern
int
OPENSOAP_API
OpenSOAPInitialize(void * /* [in] */ param) {
    int ret = OPENSOAP_NO_ERROR;

#ifndef NONGCC_WIN32
    if (!param) {
        if (!setlocale(LC_ALL, "")) {
            ret = OPENSOAP_SETLOCALEFAILURE;
        }
    }
#endif    
    ret = OpenSOAPSerializerRegistDefaults();
    
    return ret;
}

/* ultimate OpenSOAP API */
/*
=begin
---OpenSOAPInitialize(param)
   OpenSOAP API ultimate.  If use COM in OpenSOAP API,
   then CoUninitilize is called.

   :Parameters
     no parameters.
   :Return Value
      :int
	    Return Code Is ErrorCode
=end
*/
extern
int
OPENSOAP_API
OpenSOAPUltimate() {
    int ret = OPENSOAP_NO_ERROR;

    return ret;
}

    
