/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: XMLNode.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_IMPL_XMLNode_H
#define OpenSOAP_IMPL_XMLNode_H

#include "Object.h"

#include <OpenSOAP/String.h>
#include <OpenSOAP/XMLNamespace.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPXMLNode OpenSOAPXMLNode;
    typedef OpenSOAPXMLNode *OpenSOAPXMLNodePtr;
    
    struct tagOpenSOAPXMLNode {
        OpenSOAPObject          super;
        
        OpenSOAPXMLNodePtr      prev;
        OpenSOAPXMLNodePtr      next;
        OpenSOAPXMLNodePtr      parent;
        OpenSOAPXMLNodePtr      children;
        OpenSOAPStringPtr       name;
        OpenSOAPStringPtr       value;
        OpenSOAPXMLNamespacePtr thisNamespace;
    };

    int
    OpenSOAPXMLNodeInitialize(OpenSOAPXMLNodePtr /* [in, out] */ node,
                              OpenSOAPObjectFreeFunc /* [in] */ free_func);

    int
    OpenSOAPXMLNodeReleaseMembers(OpenSOAPXMLNodePtr /* [in, out] */ node);

    int
    OpenSOAPXMLNodeRelease(OpenSOAPXMLNodePtr /* [in, out] */ node);

    int
    OpenSOAPXMLNodeReleaseList(OpenSOAPXMLNodePtr /* [in, out] */ node);

    int
    OpenSOAPXMLNodeSetName(OpenSOAPXMLNodePtr /* [in, out] */ node,
                           OpenSOAPStringPtr /* [in] */ name,
                           int /* [in] */ is_dup);

    int
    OpenSOAPXMLNodeGetName(OpenSOAPXMLNodePtr /* [in] */ node,
                           OpenSOAPStringPtr * /* [out] */ name);

    int
    OpenSOAPXMLNodeInsertNext(OpenSOAPXMLNodePtr /* [in, out] */ node,
                              OpenSOAPXMLNodePtr /* [in, out] */ next);

    int
    OpenSOAPXMLNodeRemove(OpenSOAPXMLNodePtr /* [in, out] */ node);
    
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_IMPL_XMLNode_H */
