/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: FIFOSelector.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef FIFOSelector_H
#define FIFOSelector_H

#include <string>

#include "FIFOManager.h"

namespace OpenSOAP {

  class FIFODescriptor;

  //FIFOManagerƂ̂ƂɂFIFO𓾂
  class FIFOSelector {

      
    //public:
  protected:
    FIFOSelector(const std::string& ip_addr, int port);
    static const std::string LOCAL_IP_ADDR; // ="127.0.0.1";

  public:
    virtual ~FIFOSelector();
  
  public:
    //virtual int open(FIFODescriptor& fifo_d) = 0;
    virtual int open(FIFODescriptor& fifo_d, const int wait_second = FIFOManager::NO_WAIT) = 0;
    virtual int close(const FIFODescriptor& fifo_d) = 0;
    
    int connectFIFOManager();

  protected:
    //FIFODescriptor fifoDesc_;
    const std::string ip_addr_;
    const int port_;
    
  };

  //============
  //㗬gp
  //============
  class FIFOUpsideSelector : public FIFOSelector {
  public:
    FIFOUpsideSelector(int port);
    //FIFOUpsideSelector(const std::string& ip_addr, int port);
    virtual ~FIFOUpsideSelector();

    //virtual int open(FIFODescriptor& fifo_d);
    virtual int open(FIFODescriptor& fifo_d, const int wait_second = FIFOManager::NO_WAIT);
    virtual int close(const FIFODescriptor& fifo_d);
    
  };

  //============
  //gp
  //============
  class FIFODownsideSelector : public FIFOSelector {
  public:
    FIFODownsideSelector(int port);
    //FIFODownsideSelector(const std::string& ip_addr, int port);
    virtual ~FIFODownsideSelector();

    //virtual int open(FIFODescriptor& fifo_d);
    virtual int open(FIFODescriptor& fifo_d, const int wait_second = FIFOManager::NO_WAIT);
    virtual int close(const FIFODescriptor& fifo_d);
    
  };


} // end of namespace OpenSOAP


#endif /* FIFOSelector_H */
