/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: MsgDrv.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef MSG_DRV_H
#define MSG_DRV_H

#include <string>
#include <vector>
#if defined(WIN32)
#include <windows.h>
#else
#include <pthread.h>
#endif

namespace OpenSOAP {
  class ChannelDescriptor;
  
  class MsgDrv {
  private:
#if defined(WIN32)
	static int mtCount_;
	HANDLE
#else
    pthread_mutex_t
#endif
		_mt;
    bool defaultForwarding;
    bool operationExist;
    
    ChannelDescriptor chnlDesc_;
    
    unsigned int downsideTimeout, ttl;
    std::string soapMsgFromIf;
    std::string soapMsgFromSrvdrv;
    std::string fileIDOfMsgFromIf;
    std::string fileIDOfMsgFromSrvdrv;
    
    std::vector<std::string> operationNames;
    std::vector<std::string> paramNames;
    std::vector<std::string> paramValues;
    
    //    std::string localURL;
    std::vector<std::string> localURLs;
  private:
    
    //----- SrvDrv ւ̑Ms߂̃Xbh  -----//
    static 
#if defined(WIN32)
	void
#else
	void* 
#endif
		localSyncThrFunc (void* arg);

    //----- tH[hs߂̃Xbh  -----//
    static 
#if defined(WIN32)
	void
#else
	void* 
#endif
		fwdThrFunc (void* arg);

    //----- SrvDrv ւ̑M܂̓tH[hs -----//
    void* sendToSrvDrvOrFwd();
    
    //----- X|XEXv[烁bZ[W ID ɊY -----//
    //----- bZ[W̃t@C ID 擾 -----//
    void popFromResponseSpool(std::string fileIDOfMsgID);
    
    //----- X|XX|XbZ[Wɂ -----//
    bool pushToResponseSpool(std::string fileIDOfMsgFromSrvdrv);
    
    //----- (NGXg or tH[h) L[ɃbZ[W𑗂 ----//
    bool pushToQueue(bool fwdPathExist, bool fwdHopExist, 
		     bool defaultForwarding);

    //----- TTL Table ɋL^ -----/
    bool pushToTTLTable();
    
    
    //----- TTL Table 烁bZ[W ID ɑΉ -----/
    //----- backward_path T -----/
    /* ̃\bh Forwarder ɂ̂łƂ瓝 */
    bool refToTTLTable(const std::string& msgIDContent, 
		       std::string& backwardPath);
  protected:
  public:
    MsgDrv(const ChannelDescriptor& chnlDesc);
    ~MsgDrv ();
    bool run();
  };
}

#endif /* MSG_DRV_H */
