/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: soapInterface.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <iostream>
#include <string>
#include <vector>
#include <sys/types.h>

/* Channal Manager library */
#include "ChannelDescriptor.h"
#include "MsgDrvChnlSelector.h"

/* Common library */
#include "FileIDFunc.h"
#include "connection.h"

using namespace OpenSOAP;
using namespace std;

int
main (int argc, char* argv[])
{
  
  int timeout = 5;
  
  //t@CfBXNv^
  ChannelDescriptor chnlDesc;
  
  ChannelSelector* chnlSelector = new MsgDrvChnlSelector();
  
//    if (0 != chnlSelector->open(chnlDesc, timeout)) {
  if (0 != chnlSelector->open(chnlDesc)) {
    cerr << "open failed" << endl;
    return EXIT_FAILURE;
  }
  
  cerr << "TRANS IF: read ready." << endl;
  
  //==============================
  //ʐM(START)
  //==============================
  
  // W͂ SOAP bZ[Wǂݍ
  std::string soapMsgFromClient;
  recvStdin(soapMsgFromClient);
  
  // t@C ID 擾
  std::string fileIDOfMsgFromClientMsg = convertToFileID(soapMsgFromClient);
  
  // 
  cerr << "TRANS IF: write ready." << endl;
  
  if (0 > chnlDesc.write(fileIDOfMsgFromClientMsg)) {
    cerr << "TRANS IF: write failed" << endl;
    return EXIT_FAILURE;
  }
  cerr << "TRANS IF: write done." << endl;
  
  // ǂݍ
  std::string fileIDOfMsgFromMsgDrv;
  std::string readData;
  if (0 > chnlDesc.read(fileIDOfMsgFromMsgDrv)) {
    cerr << "TRANS IF: write failed" << endl;
    return EXIT_FAILURE;
  }

  cerr << "TRANS IF::READ=[" << readData << "]" << endl;
  //==============================
  //ʐM(END)
  //==============================
  
  //N[Y
  chnlSelector->close(chnlDesc);

  delete chnlSelector;
  
  // t@C ID t@C̓eɕϊ
  std::string soapMsgFromMsgDrv;
  soapMsgFromMsgDrv = revertFromFileID (fileIDOfMsgFromMsgDrv);
  
  // Wo͂ɏoB
  sendStdout ("Content-Type: text/xml; charset=EUC-JP\r\n");
  sendStdout (soapMsgFromMsgDrv);
  
  return EXIT_SUCCESS;

}

